#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cdiroutl"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TfmMainForm *fmMainForm;
#include "MyFunction.cpp"
//---------------------------------------------------------------------------
__fastcall TfmMainForm::TfmMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FormCreate(TObject *Sender)
{
    LoadSetting();  // J]w
    FileListBox1->Mask = FilterComboBox1->Mask;
    CDirectoryOutline1->Drive = DriveComboBox1->Drive;
    FileListBox1->Directory = CDirectoryOutline1->Directory;
    maxWidth = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FormDestroy(TObject *Sender)
{
    delete iniSetting;
    if( FileExists("temp.bat") )
        DeleteFile("temp.bat");
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FilterComboBox1Change(TObject *Sender)
{
    FileListBox1->Mask = FilterComboBox1->Mask;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::CDirectoryOutline1Change(TObject *Sender)
{
    FileListBox1->Directory = CDirectoryOutline1->Directory;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::DriveComboBox1Change(TObject *Sender)
{
    CDirectoryOutline1->Drive = DriveComboBox1->Drive;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::btnExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::smExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FileListBox1DblClick(TObject *Sender)
{
    if( ListBox1->Items->IndexOf( FileListBox1->FileName ) == -1 )  // Y٨S[J
    {
        ListBox1->Items->Add( FileListBox1->FileName );

		// ʺAͤb
        int width = ListBox1->Canvas->TextWidth( FileListBox1->FileName ) + 100;
        if( maxWidth < width )
        {
            maxWidth = width;
            ListBox1->ScrollWidth = maxWidth;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::ListBox1DblClick(TObject *Sender)
{
    ListBox1->Items->Delete( ListBox1->ItemIndex );

    // ʺAͤb
    maxWidth = 0;
    int width;
    for( int i = 0; i < ListBox1->Count; i++ )
    {
        width = ListBox1->Canvas->TextWidth(ListBox1->Items->Strings[i]) + 100;
        if( maxWidth < width )
            maxWidth = width;
    }
    ListBox1->ScrollWidth = maxWidth;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::btnAddAllClick(TObject *Sender)
{
    String s = CDirectoryOutline1->Directory + "\\";
    int width;
    for( int i = 0; i < FileListBox1->Count; i++ )
    {
        if( ListBox1->Items->IndexOf( s + FileListBox1->Items->Strings[i] ) == -1 )
            ListBox1->Items->Add( s + FileListBox1->Items->Strings[i] );

        // ʺAͤb
        width = ListBox1->Canvas->TextWidth( s + FileListBox1->Items->Strings[i] ) + 100;
        if( maxWidth < width )
        {
            maxWidth = width;
            ListBox1->ScrollWidth = maxWidth;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::btnRemoveAllClick(TObject *Sender)
{
    ListBox1->Clear();
    ListBox1->ScrollWidth = 0;
    maxWidth = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::rdoCompressClick(TObject *Sender)
{
    SwitchEnabled( true );
}
//---------------------------------------------------------------------------

void __fastcall TfmMainForm::rdoDecompressClick(TObject *Sender)
{
    SwitchEnabled( false );
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::btnGoClick(TObject *Sender)
{
    if( ListBox1->Count > 0 )   // ɮ׭nQY~HU
    {
        TStringList *sl = new TStringList;
        String s = "upx ";
        if( cbBackup->Checked )
            s += "-k ";
        if( rdoCompress->Checked )
        {
            s += "--crp-ms=999999 --nrv2d ";
            if( CSpinEdit1->Value == 10 )
                s += "--best ";
            else
                s = s + "-" + CSpinEdit1->Text + " ";

            if( rdoCopy->Checked )
                s += "--overlay=copy ";
            else if( rdoSkip->Checked )
                s += "--overlay=skip ";
            else
                s += "--overlay=strip ";

            if( cbExportData->Checked )
                s += "--compress-exports=1 ";
            else
                s += "--compress-exports=0 ";

            if( cbIcon->Checked )
                s += "--compress-icons=" + CSpinEdit2->Text + " ";
            else
                s += "--compress-icons=0 ";

            if( cbRelocate->Checked )
                s += "--strip-relocs=1 ";
            else
                s += "--strip-relocs=0 ";
        }
        else
            s += "-d ";

        for( int i = 0; i < ListBox1->Count; i++ )
            s += "\"" + ListBox1->Items->Strings[i] + "\" ";
        sl->Add("CLS");
        sl->Add("@ECHO OFF");
        sl->Add(s);
        if( cbShowResult->Checked )
            sl->Add("PAUSE");
        sl->Add("EXIT");
        sl->SaveToFile("temp.bat");
        delete sl;
        ShellExecute(NULL, NULL, "temp.bat", NULL, NULL, SW_SHOW);
    }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::mmAboutClick(TObject *Sender)
{
    TfmAboutForm *Form2;
    Form2 = new TfmAboutForm(Application);
    Form2->ShowModal();    
}
//---------------------------------------------------------------------------

void __fastcall TfmMainForm::smSaveSettingsClick(TObject *Sender)
{
    SaveSetting();
}
//---------------------------------------------------------------------------
